

/*
// Create components
new audioMixerCpt = new AudioMixer(numSamples,channels);
new windowCpt = new Window();
new fftMagnitudeCpt = new FFTRealMagnitude();

// Wire them up

windowCpt.setInput("input",audioMixerCpt.getOutput("mixedFrames"));
fftMagnitudeCpt.setInput("input",audioMixerCpt.getOutput("output"));

*/



// *******
// *******

function ActiveWorkflow(transformMode,frameBufferLength,concatLimit,channels,samplerate,totalNumFrames) {

    // Create components
    var audioMixerCpt   = new AudioMixer(frameBufferLength/channels,channels);
    var freqSpectrumCpt = new WFFreqSpectrum(frameBufferLength*concatLimit,channels,samplerate,totalNumFrames);
    var filterBankCpt   = new WFFilterBank(frameBufferLength*concatLimit,channels,samplerate,totalNumFrames);
    var chromaCpt       = new WFChromaTransform(transformMode,frameBufferLength*concatLimit,channels,samplerate,totalNumFrames);
    
    // Wire components up
    audioMixerCpt.connectOutput("mixedFrames", freqSpectrumCpt, "monoAudioInputFrames");
    freqSpectrumCpt.connectOutput("freqSpectrumFrames", filterBankCpt, "freqSpectrumInputFrames");
    filterBankCpt.connectOutput("filterBankFrames", chromaCpt, "inputFrames");

    var that = new Workflow(audioMixerCpt);
    
    that.initialize();

    that.audioMixerCpt   = audioMixerCpt;
    that.freqSpectrumCpt = freqSpectrumCpt;
    that.filterBankCpt   = filterBankCpt;
    that.chromaCpt       = chromaCpt;

    return that;
}

//ActiveWorkflow.swiss(Workflow, 'pumpDataHead');
