
var WFFreqSpectrum = function(frameBufferLength,channels,samplerate,totalNumFrames) {

    this.frameBufferLength = frameBufferLength;
    this.channels = channels;
    this.samplerate = samplerate;
   
    this.totalNumFrames = totalNumFrames; // **** Not currently used 

    this.defaults();

    var fftWindowSize = Math.floor(this.frameBufferLength/channels); // check this is a power of 2??

    this.fft = new FFTCustom(fftWindowSize, this.samplerate);

    this.freqSpectrumSequence = new Array();
}

WFFreqSpectrum.inherits(Component);

//----------------------------- OVERVIEW -----------------------------------------------------

WFFreqSpectrum.staticfield('Component', {

    creator:     "David Bainbridge", 
    description: "Overview: Computes the frequency spectrum of the (mono-valued) input frame",
    name:        "freqSpectrum", 
    tags:        "signal process, frequency-spectrum",
    dependency: [ "dsp.js" ]
});

//------------------------------ INPUTS ------------------------------------------------------

WFFreqSpectrum.staticfield('ComponentInputArray', [
    {
	name: "monoAudioInputFrames",
	description: "Frames of (mono, or stereo down-mixed to mono) audio."
    }

]);


//------------------------------ PROPERTIES --------------------------------------------------

WFFreqSpectrum.staticfield('ComponentPropertyArray', [
]);


//------------------------------ OUTPUTS -----------------------------------------------------

WFFreqSpectrum.staticfield('ComponentOutputArray', [
    {
	name: "freqSpectrumFrames",
	description: "Per frame frequency spectrum (potentially the power spectrum, based on the Component's parameters"
    }
]);



WFFreqSpectrum.prototype.reset = function()
{
    this.maxval = 0.0;
}


WFFreqSpectrum.prototype.setMaxVal = function(v)
{
    this.maxval = v;
}


WFFreqSpectrum.prototype.getMaxVal = function()
{
    var maxVal = this.maxval;

    return maxVal;
}

WFFreqSpectrum.prototype.getFreqSpectrumSequence  = function() {
    return this.freqSpectrumSequence;
}


// ******
// ******



WFFreqSpectrum.prototype.defaults = function() {
};


WFFreqSpectrum.prototype.initializeCallback = function(ccp) {
}


WFFreqSpectrum.prototype.executeCallBack = function(cc) {
    
    // typeof(cc) => ComponentContext
    
    // get the "[D" input

    //console.info("*** WFFreqSpectrum::executeCallBack(): away to request 'monoAudioInputFrames'");

    var frame = cc.getDataComponentFromInput("monoAudioInputFrames");

    this.fft.forward(frame);
    
    var freqSpectrumCopy = new Float32Array(this.fft.powerSpectrum); // need a copy of the array (not just a reference)
    this.freqSpectrumSequence.push(freqSpectrumCopy); 

    cc.pushDataComponentToOutput("freqSpectrumFrames",this.fft.powerSpectrum);

}

