

// ******
// Base class elements
// ******

var Window = function() {

    this.getset = {};
}

Window.prototype.setProperty = function(p,v) {

    this.getset[p] = v;
}

Window.prototype.getProperty = function(p) {

    return getset[p];
}

// ******
// End of base class elements
// ******

Window.Component = {   

    creator: "David Bainbridge",

    description: "Overview: This module applies a Hamming window to the input array"
        + " The input data is not modified.",

    name: "Window",
    
    tags: "apply a Hamming window to an array"
};

AudioMixer.ComponentInputArray = [
    {
	description:  "input values(1-D double array)",
        name:         "input"
    }
];


AudioMixer.ComponentPropertyArray = [

    {
	defaultValue: "Hamming",
        description:  "The name of the window function which can be Rectangular, Bartlett, Blackman, Hanning, Hamming.",
        name:         "windowName"
    }
];

AudioMixer.ComponentOutputArray = [
 
    {
	description:  "output(1-D double array)",
        name:         "output"
    }
];


    /**
     * Window type to use.
     */
    private String WindowName = "Rectangular";
    private WindowClass theWindow = null;
    //~--- methods ------------------------------------------------------------

    /**Initialises variables before execution */
    public void initializeCallback(ComponentContextProperties ccp) {
        theWindow = new WindowClass(WindowName);
    }


    /**
     * Applies a specified window to the input array. Currently, four window functions
     * are implemented. Rectangular, Bartlett, Hanning, and Hamming.
     *
     */
    public void executeCallback(ComponentContext cc)
            throws ComponentExecutionException, ComponentContextException {
        
        WindowName = (String)(cc.getProperty(DATA_PROPERTY));
        theWindow.setWindowName(WindowName); //reset parameters

        
        Object input = cc.getDataComponentFromInput(DATA_INPUT);
        if (input instanceof StreamTerminator){
            cc.pushDataComponentToOutput(DATA_OUTPUT, input);
        }else{
            double[] double1DArray = (double[])(input);

	    // Actually doing rectangular here !!!

            double[] output = theWindow.applyWindow(double1DArray);

            cc.pushDataComponentToOutput(DATA_OUTPUT, output);
            
            
        }
    }

    public void dispose(ComponentContextProperties ccp) {}

}